//  var baseUrl = "192.168.10.110"; //local url
var baseUrl = "http://api.radshid.com/";
var apiUrl = baseUrl + "api/";
var apiVersion = apiUrl + "v1/"
var apiVersion2 = apiUrl + "v2/"
var authenticateRequestUrl = apiVersion2 + "users/authenticate";
var usersRequestUrl = apiVersion + "users";
var usersCheckRequestUrl = apiVersion + "users/check?"; //'https://api.radshid.com/api/v1/users/check?imei=' + serial + '&registerCode=' + regcode + '&username=' + user
var pointsRequestUrl = apiVersion + "points";
var carsRequestUrl = apiVersion + "cars/"; //url: 'https://api.radshid.com/api/v1/cars/' + carId + '/points?from=' + from + '&to=' + to
//var carsCheckRequestUrl = requestUrl + "cars/check?"; // url: 'https://api.radshid.com/api/v1/users/check?imei=' + serial + '&registerCode=' + regcode + '&username=' + user
var versionCheckRequestUrl = apiUrl + "v1/AndroidApplication/LastVersion";
var responseVersionCheck;
var lastVersionDownloadUrl = "http://spa.radshid.com/?act=android";

function VersionCheckApi(callback) {
    axios({
        method: 'get',
        url: versionCheckRequestUrl,
        timeout: 25000
    })
        .then(function (response) {
            if (response.status === 200) {
                responseVersionCheck = response.data;
                callback();
            }
        })
        .catch(function (error) {
            LoginAndNavigate();
        })
}


function Login(result) {
    GetUserDeviceInfo(function () {

        try {
            axios({
                method: 'post',
                url: authenticateRequestUrl,
                headers: {
                    "Content-Type": "application/json",
                    "domain": agentDomain
                },
                timeout: 25000,
                data: {
                    username: username,
                    password: password,
                    deviceId: deviceId,
                    platform: platform1,
                    platformversion: platformVersion,
                    manufacturer: manufacturer,
                    model: model,
                    uuid: uuid,
                    serial: serial,
                    isvirtual: isVirtual,
                    cordovaversion: cordovaVersion,
                    appversion: versionCode
                }
            })
                .then(function (response) {
                    if (response.status === 200 && response.data.token) {

                        token = response.data.token;
                        tokenExpiration = response.data.expiration;

                        localStorage.setItem("username", username);
                        localStorage.setItem("password", GenerateHash(password));
                        localStorage.setItem("token", GenerateHash(token));
                        localStorage.setItem("tokenExpiration", tokenExpiration);

                        if (deviceId != response.data.deviceId) {
                            deviceId = response.data.deviceId;
                            localStorage.setItem("deviceId", deviceId);
                        }

                        SessionStorageSetAllItem();

                        result(true);
                    }
                    else {
                        showAlert(i18n('somethingWentWrong'), 'danger');
                        result(false);
                    }
                })
                .catch(function (error) {
                    showAlert(i18n('invalidLogin'), 'danger');
                    result(false);
                })
                .finally(function () {
                    $('.loadingContainer').fadeOut();
                });


        } catch (error) {
            console.error(error)
        }
    });

}

function GetAllCars() {
    axios({
        method: 'get',
        url: pointsRequestUrl,
        headers: {
            "Content-Type": "application/json",
            "Authorization": "Bearer " + token
        },
        timeout: 25000
    })
        .then(function (response) {
            if (response.status === 200) {
                carsObjectTemp = response.data;
                carsObject = {};
                for (let i = 0; i < carsObjectTemp.length; i++) {
                    carsObject[carsObjectTemp[i].id] =
                    {
                        carName: carsObjectTemp[i].title,
                        sim: carsObjectTemp[i].simPhone,
                        carId: carsObjectTemp[i].id
                    }

                }


                localStorage.setItem("carsObject", JSON.stringify(carsObject));
                sessionStorage.setItem("carsObject", JSON.stringify(carsObject));
            }
        })
        .catch(function (error) {
            setTimeout(function () {
                showAlert(i18n('somethingWentWrong'), 'danger', 4000);
            }, 5000);
        });
}