var canShowAlert = true;
var agentDomain = "drakavl.ir";

var versionName;
var versionCode;

var deviceId;
var platform1;
var platformVersion;
var manufacturer;
var model;
var uuid;
var serial;
var isVirtual;
var cordovaVersion;

var username;
var password;

var token;
var tokenExpiration;

var saveLogin;
var autoLogin;
var lang;

var splash;
var carObjects;
var carsObject;
var selectedCar;


function SessionStorageGetAllItem() {
    if (typeof (Storage) !== "undefined") {
        versionName = sessionStorage.getItem('versionName');
        versionCode = sessionStorage.getItem('versionCode');
        if (sessionStorage.getItem('deviceId') == null)
            deviceId = 0;
        else
            deviceId = parseInt(sessionStorage.getItem('deviceId'));

        saveLogin = sessionStorage.getItem('saveLogin');
        autoLogin = sessionStorage.getItem('autoLogin');
        lang = sessionStorage.getItem('lang');
        setLanguage(lang);

        username = sessionStorage.getItem('username');
        password = sessionStorage.getItem('password');

        token = sessionStorage.getItem('token');
        tokenExpiration = sessionStorage.getItem('tokenExpiration');

        splash = sessionStorage.getItem('splash');
        carObjects = sessionStorage.getItem('carObjects');
        if (sessionStorage.getItem('carsObject') !== "undefined")
            carsObject = JSON.parse(sessionStorage.getItem('carsObject'));

        if (sessionStorage.getItem('selectedCar') !== "undefined")
            selectedCar = JSON.parse(sessionStorage.getItem('selectedCar'));

    } else {
        console.error("Sorry, your browser does not support Web Storage...");
    }
}


function SessionStorageSetAllItem() {
    if (typeof (Storage) !== "undefined") {
        sessionStorage.setItem('versionName', versionName);
        sessionStorage.setItem('versionCode', versionCode);
        sessionStorage.setItem('deviceId', deviceId);

        sessionStorage.setItem('saveLogin', saveLogin);
        sessionStorage.setItem('autoLogin', autoLogin);
        sessionStorage.setItem('lang', lang);

        sessionStorage.setItem('username', username);
        sessionStorage.setItem('password', password);

        sessionStorage.setItem('token', token);
        sessionStorage.setItem('tokenExpiration', tokenExpiration);

        sessionStorage.setItem('splash', splash);
        sessionStorage.setItem('carObjects', carObjects);
        sessionStorage.setItem('carsObject', JSON.stringify(carsObject));
        sessionStorage.setItem('selectedCar', JSON.stringify(selectedCar));
    } else {
        console.error("Sorry, your browser does not support Web Storage...");
    }
}


function LocalStorageGetAllItem() {
    try {
        if (typeof (Storage) !== "undefined") {
            versionName = localStorage.getItem('versionName');
            versionCode = localStorage.getItem('versionCode');
            if (localStorage.getItem('deviceId') == null)
                deviceId = 0;
            else
                deviceId = parseInt(localStorage.getItem('deviceId'));

            saveLogin = localStorage.getItem('saveLogin');
            autoLogin = localStorage.getItem('autoLogin');
            lang = localStorage.getItem('lang');
            setLanguage(lang);

            username = localStorage.getItem('username');
            password = DeserializeHash(localStorage.getItem("password"));


            token = DeserializeHash(localStorage.getItem("token"));
            tokenExpiration = localStorage.getItem('tokenExpiration');

            splash = localStorage.getItem('splash');
            carObjects = localStorage.getItem('carObjects');

            if (localStorage.getItem('carsObject') !== "undefined")
                carsObject = JSON.parse(localStorage.getItem('carsObject'));

            if (localStorage.getItem('selectedCar') !== "undefined")
                selectedCar = JSON.parse(localStorage.getItem('selectedCar'));
        } else {
            console.error("Sorry, your browser does not support Web Storage...");
        }
    }
    catch {

    }
}


function LocalStorageSetAllItem() {
    if (typeof (Storage) !== "undefined") {
        localStorage.setItem('versionName', versionName);
        localStorage.setItem('versionCode', versionCode);
        localStorage.setItem('deviceId', deviceId);

        localStorage.setItem('saveLogin', saveLogin);
        localStorage.setItem('autoLogin', autoLogin);
        localStorage.setItem('lang', lang);

        localStorage.setItem('username', username);
        localStorage.setItem("password", GenerateHash(password));

        localStorage.setItem('token', GenerateHash(token));
        localStorage.setItem('tokenExpiration', tokenExpiration);

        localStorage.setItem('splash', splash);
        localStorage.setItem('carObjects', carObjects);
        localStorage.setItem('carsObject', JSON.stringify(carsObject));
        localStorage.setItem('selectedCar', JSON.stringify(selectedCar));
    } else {
        console.error("Sorry, your browser does not support Web Storage...");
    }
}


function GenerateHash(text) {
    return CryptoJS.AES.encrypt(text, i18n('hashpswd', { r: '|^', a: '@', d: '|)', s: '$', h: '|-|', i: '!' }));
}

function DeserializeHash(text) {
    deserializeHash = "";
    try {
        deserializeHash = CryptoJS.AES.decrypt(text, i18n('hashpswd', { r: '|^', a: '@', d: '|)', s: '$', h: '|-|', i: '!' })).toString(CryptoJS.enc.Utf8);
    } catch (error) {
        deserializeHash = "";
    }
    return deserializeHash;
}

//namayesh payamha
function showAlert(message, type, delay) {
    if (!delay)
        delay = 3000;

    if (!type)
        type = 'danger';

    if (canShowAlert) {
        canShowAlert = false;
        $('.alert').addClass('alert-' + type);
        $('.alert').html(message);
        $('.alert').slideToggle(800);
        setTimeout(function () {
            $('.alert').slideToggle(800);
            setTimeout(function () {
                $('.alert').removeClass('alert-' + type);
                canShowAlert = true;
            }, 1000);
        }, delay);
    }
}


function getMetersPerPixel() {
    var centerLatLng = map.getCenter(); // get map center
    var pointC = map.latLngToContainerPoint(centerLatLng); // convert to containerpoint (pixels)
    var pointX = [pointC.x + 1, pointC.y]; // add one pixel to x
    var pointY = [pointC.x, pointC.y + 1]; // add one pixel to y

    // convert containerpoints to latlng's
    var latLngC = map.containerPointToLatLng(pointC);
    var latLngX = map.containerPointToLatLng(pointX);
    var latLngY = map.containerPointToLatLng(pointY);

    var distanceX = latLngC.distanceTo(latLngX); // calculate distance between c and x (latitude)
    var distanceY = latLngC.distanceTo(latLngY);  // calculate distance between c and y (longitude)
    return [distanceX, distanceY];
}

function getCorrectUnitOfMeter(num) {
    return (num / 1000) >= 1 ? Math.round((num / 1000)) + ' km' : Math.round(num) + ' m';
}

function GoToPage(pageName, delay) {
    if (!delay)
        delay = 2000;

    setTimeout(function () {
        location.href = pageName;
    }, delay);
}

function ExitCheck() {
    var exitConfirm = false;
    document.addEventListener("backbutton", onBackKeyDown, false);
    function onBackKeyDown(e) {
        e.preventDefault();
        if (exitConfirm) {
            navigator.app.exitApp();
        }
        else {
            exitConfirm = true;
            showAlert(i18n('exitConfirm'), 'secondary', 2000);
            setTimeout(function () {
                exitConfirm = false;
            }, 2000);
        }
    }
}

function GetUserDeviceInfo(callback) {

    if (device.platform == "browser") {
        versionCode = 0;
        platform1 = "browser";
        platformVersion = "test";
        manufacturer = "test";
        model = "test";
        uuid = "test";
        serial = "test";
        isVirtual = false;
        cordovaVersion = "test";

        callback();
    }
    else {
        cordova.getAppVersion.getVersionCode(function (versionC) {
            versionCode = versionC;

            platform1 = device.platform;
            platformVersion = device.version;
            manufacturer = device.manufacturer;
            model = device.model;
            uuid = device.uuid;
            serial = device.serial;
            isVirtual = device.isVirtual;
            cordovaVersion = device.cordova;

            callback();
            // alert("versionName " + versionName);
            // alert("versionCode " + versionCode);
            // alert("platform " + platform);
            // alert("platformVersion " + platformVersion);
            // alert("manufacturer " + manufacturer);
            // alert("model " + model);
            // alert("uuid " + uuid);
            // alert("serial " + serial);
            // alert("isVirtual " + isVirtual);
            // alert("cordovaVersion " + cordovaVersion);
        });
    }
}

function LoginAndNavigate(delay) {
    if (!delay)
        delay = 2000;

    if (token && tokenExpiration) {
        var time = Date.now();
        tokenExpiration = tokenExpiration.replace('T', ' ');
        var tokenExpirationTime = new Date(tokenExpiration + ' UTC');


        if ((tokenExpirationTime.getTime() - time) > (5 * 60 * 60)) { //agar token ta 5 saat digar (18.000.000) etebar dasht
            GoToPage("./map.html", delay);
        }
        else if (username && password) {
            Login(function (result) {
                if (result)
                    GoToPage("./map.html", delay);
                else
                    GoToPage("./login.html", delay);

            });
        }
        else {
            GoToPage("./login.html", delay);
        }
    }
    else {
        GoToPage("./login.html", delay);
    }
}

function ConvertPersianToEngChar(str) {
    var persianNumbers = ['۰', '۱', '۲', '۳', '۴', '۵', '۶', '۷', '۸', '۹'];
    for (var i = 0; i < 10; i++) {
        str = str.split(persianNumbers[i]).join(i);
    }
    return str;
}
