var mylocationMarker = undefined;
var mylocationCricleMarker = undefined;
var myLastLocation = undefined;
var myLastAccuracy = undefined;
var isFirstShowMe = true;
var shouldUpdateCricle = false;
var canUpdateMyGps = true;
var polyline = undefined;
var distanceToCar = undefined;
var polylineLatlngs;


function onSuccessGPS(position) {
    shouldUpdateCricle = false;
    if (canUpdateMyGps) {
        if (mylocationMarker)
            mylocationMarker.removeFrom(map);
        if (mylocationCricleMarker)
            mylocationCricleMarker.removeFrom(map);

        myLastLocation = [position.coords.latitude, position.coords.longitude];
        myLastAccuracy = position.coords.accuracy;

        mylocationMarker = new L.circleMarker(myLastLocation, {
            radius: 7,
            fillColor: "#2d7fff",
            stroke: true,
            color: "#fff",
            weight: 2,
            opacity: 1,
            fillOpacity: 1
        });
        mylocationMarker.addTo(map);

        var metresPerPixel = getMetersPerPixel();
        mylocationCricleMarker = L.circleMarker(myLastLocation,
            {
                radius: myLastAccuracy / metresPerPixel[0],
                fillColor: "#2d7fff",
                stroke: true,
                color: "#2371ff",
                weight: 1,
                opacity: 1,
                fillOpacity: 0.2
            });
        if (myLastAccuracy / metresPerPixel[0] > 7 && myLastAccuracy < 500) {
            myLocationGLayer.addLayer(mylocationCricleMarker);
        }

        //fit
        // var carIdList = Object.keys(globalMarkersList);
        var cars = Object.keys(filterShowCar).filter(x => filterShowCar[x] == true);
        if (cars.length === 1) {
            try {
                polyline.removeFrom(map);
            } catch (error) {

            }
            var carMarker = globalMarkersList[cars];
            // create a red polyline from an array of LatLng points
            polylineLatlngs = [
                myLastLocation,
                carMarker.getLatLng()
            ];

            polyline = L.polyline(polylineLatlngs, { color: 'gray', dashArray: '20, 20', dashOffset: '0' });
            //polyline.bindTooltip(distanceToCar, { permanent: true });
            polyline.addTo(map);
            DistanceUpdate();

            if (isFirstShowMe) {
                var markerListToPin = [];
                markerListToPin.push(carMarker);

                markerListToPin.push(mylocationMarker);
                var markersGroup = new L.featureGroup(markerListToPin);
                map.fitBounds(markersGroup.getBounds());
                isFirstShowMe = false;
            }
        }
    }
    shouldUpdateCricle = true;
}

function onErrorGPS(error) {
    console.error('code: ' + error.code + '\n' + 'message: ' + error.message);
}


function startWatchingGPS() {
    var permissions = cordova.plugins.permissions;
    permissions.hasPermission(permissions.ACCESS_COARSE_LOCATION, function (status) {
        if (status.hasPermission) {
            HaveLocationPermission()
        }
        else {
            permissions.requestPermission(permissions.ACCESS_COARSE_LOCATION, success, error);
            stopWatchingGPS();
        }
    });
}

function success() {
    var permissions = cordova.plugins.permissions;
    permissions.hasPermission(permissions.ACCESS_COARSE_LOCATION, function (status) {
        if (status.hasPermission) {
            HaveLocationPermission
        }
    });
}
function error() {
    showAlert(i18n('somethingWentWrong'), 'info', 2000);
}

function HaveLocationPermission() {
    cordova.plugins.diagnostic.isGpsLocationAvailable(function (available) {
        if (available) {
            $('#whereAmI svg').css('fill', '#4d8bbb');
            myLocationGLayer.addTo(map);
            watchId = navigator.geolocation.watchPosition(onSuccessGPS, onErrorGPS, { enableHighAccuracy: true });
            isMyLocationAvtive = true;
        }
        else {
            showAlert(i18n('turnGpsOn'), 'info', 2000);
            setTimeout(function () {
                cordova.plugins.diagnostic.switchToLocationSettings();
            }, 2000);
            stopWatchingGPS();
        }
    }, function (error) {
        showAlert(i18n('somethingWentWrong'), 'info', 2000);
    });
}

function stopWatchingGPS() {
    $('#whereAmI svg').css('fill', 'gray');
    try {
        navigator.geolocation.clearWatch(watchId);
    } catch (error) {

    }
    if (mylocationMarker)
        mylocationMarker.removeFrom(map);
    if (mylocationCricleMarker)
        myLocationGLayer.clearLayers();

    try {
        polyline.removeFrom(map);
    } catch (error) {

    }
    polyline = undefined;
    isFirstShowMe = true;
    shouldUpdateCricle = false;
    myLocationGLayer.removeFrom(map);
    distanceToCar = undefined;
    isMyLocationAvtive = false;
}