var activeMode = undefined;


// function to set language
function setLanguage(lang) {

    // update marker if liveShow is active
    if (activeMode && activeMode === "liveShow") {
        updateTracker();
    }

    if (lang === 'fa' || lang === 'ar') {
        $('.alert').css('direction', 'rtl');
        $('.text-left').addClass('text-right');
        $('.text-left').removeClass('text-left');
    }
    else if (lang === 'en') {
        $('.alert').css('direction', 'ltr');
        $('.text-right').addClass('text-left');
        $('.text-right').removeClass('text-right');
    }
    else {
        lang = 'fa';
        $('.alert').css('direction', 'rtl');
        $('.text-left').addClass('text-right');
        $('.text-left').removeClass('text-left');
    }

    $('html').attr('id', lang);
    
    try {
        $.ajax({ url: lang + ".json", async: false })
            .done(function (text) {
                i18n.translator.add(JSON.parse(text));
            });
    } catch (error) {
        try {
            $.ajax({ url: lang + ".json", async: false })
                .done(function (text) {
                    i18n.translator.add(text);
                });
        } catch (er) {
        }
    }
    var elements = $("[translate]").toArray();
    elements.forEach(el => {
        var text = i18n(el.getAttribute('translate'));
        var translatePlace = el.getAttribute('translatePlace');
        if (translatePlace) {
            switch (translatePlace.toLowerCase()) {
                case 'placeholder':
                    el.setAttribute("placeholder", text);
                    break;
                case 'innertext':
                    el.innerText = text;
                    break;
                case 'alt':
                    el.setAttribute("alt", text);
                    break;
            }
        }
        else {
            el.innerHTML = text;
        }
    });

    sessionStorage.setItem('lang', lang);
    if (typeof (Storage) !== "undefined") {
        localStorage.setItem("lang", lang);
    } else {
        console.error("Sorry, your browser does not support Web Storage...");
    }
}